import 'dart:io';

class Routing {
  Map<String, Function> routes = Map();
  
  Routing(HttpServer server){
    handleRequests(server);
  }

  handleRequests(server) async{
    await for (HttpRequest req in server) {
      req.response.headers.contentType = ContentType.json;
      if (routes.containsKey(req.method + req.uri.path)) {
        routes[req.method + req.uri.path](req);
      }
      req.response.close();
    }
  }

  get(String path, Function callback) {
    routes.putIfAbsent("GET" + path, () => callback);
  }

  post(String path, Function callback) {
    routes.putIfAbsent("POST" + path, () => callback);
  }
}
